﻿Type=Class
Version=2.2
B4J=true
@EndOfDesignText@
'WebSocket class
' File: webapplocalize.bas
' Module Type: WebSocket class
' Purpose: Start the webapp page to execute selected functions
' Changed: See readme.txt
' 
Sub Class_Globals
	Private ws As WebSocket
	Private JSONfile As String = "webapplocalize.json"
	Private JSONLocalize As String = "localize.json"
	
	Private dlgmessage As JQueryElement
	Private fieldMessage As JQueryElement

	Private btnSend As JQueryElement	
	Private btnConfiguration As JQueryElement	
	Private btnAbout As JQueryElement	
	Private btnLocalize As JQueryElement	

	Private fieldTo As JQueryElement
	Private fieldSubject As JQueryElement
	Private fieldBody As JQueryElement
	Private lblTo As JQueryElement
	Private lblSubject As JQueryElement
	Private lblBody As JQueryElement

	Private dlgconfiguration As JQueryElement
	Private fieldmailserver As JQueryElement
	Private fieldport As JQueryElement
	Private fieldusername As JQueryElement
	Private fieldpassword As JQueryElement

	Private lblTitle As JQueryElement
	Private lblFooter As JQueryElement

	Private gmapSettings As Map
	Private gstrLanguage As String = "EN"
End Sub

Public Sub Initialize
	
End Sub

' User connects to the server by opening up index.html.
Private Sub WebSocket_Connected (WebSocket1 As WebSocket)
	Main.AppLog("WebSocket_Connected :: Start")
	'
	' Init the global settings map
	gmapSettings.Initialize
	' Assigng the websocket
	ws = WebSocket1
	' Read the config into global map gmapSettings
	readConfig
	fieldTo.SetVal(gmapSettings.GetDefault("lastto", "name@address.com"))
	' Update various labels
	lblTitle.SetText(Main.CAPPTITLE)
	lblFooter.SetText(Main.CAPPCOPYRIGHT)
	'
	Main.AppLog("WebSocket_Connected :: End")
End Sub

' Send the email
Sub btnSend_Click(Params As Map)
	ws.Alert("Send Clicked")	
End Sub

' Show the configuration dialog populated with latest config values
Sub btnConfiguration_Click(Params As Map)
	Main.AppLog("btnConfiguration :: Start")
	' Read the config to get the latest values
	readConfig
	' Update the configuration dialog fields from the global map gmapSettings
	fieldmailserver.SetVal(gmapSettings.Get("mailserver"))
	fieldport.SetVal(gmapSettings.Get("port"))
	fieldusername.SetVal(gmapSettings.Get("username"))
	fieldpassword.SetVal(gmapSettings.Get("password"))
	' Open the configuration dialog
	ws.RunFunction("OpenDialog", Array As String(dlgconfiguration.Id))
	Main.AppLog("btnConfiguration :: End")
End Sub

' Configuration dialog Button OK clicked
Sub btnconfigurationok_Event(Params As Map)
	Main.AppLog("btnconfigurationok :: Start")
	'TODO: Add checkConfigurationFields befor saving
	'
	gmapSettings.Put("mailserver", fieldmailserver.GetVal.Value)
	gmapSettings.Put("port", fieldport.GetVal.Value)
	gmapSettings.Put("username", fieldusername.GetVal.Value)
	gmapSettings.Put("password", fieldpassword.GetVal.Value)
	writeConfig
	'
	Main.AppLog("btnconfigurationok :: End")
End Sub

' Show information about this app
Sub btnAbout_Click(Params As Map)
	showMessage(Main.CAPPTITLE & CRLF & Main.CAPPVERSION & CRLF & Main.CAPPCOPYRIGHT)
	' ws.Alert(Main.CAPPTITLE & CRLF & Main.CAPPVERSION & CRLF & Main.CAPPCOPYRIGHT)
End Sub

' LOcalize = switch between EN and DE as Test
Sub btnLocalize_Click(Params As Map)
	readLocalization
End Sub

Sub showMessage(msg As String)
	fieldMessage.SetVal(msg)
	ws.RunFunction("OpenDialog", Array As String(dlgmessage.Id))
End Sub

' Read the JSON file structure in the global map
Sub readConfig
	Main.AppLog("ReadConfig :: Start")
	Dim JSON As JSONParser
	JSON.Initialize(File.ReadString(File.DirApp, JSONfile))
	Dim l As List
	l = JSON.NextArray
	gmapSettings = l.Get(0)
	Main.AppLog("> Mailserver:" & gmapSettings.Get("mailserver"))
	Main.AppLog("ReadConfig :: End")
End Sub

' Write the updated structure in the global map
Sub writeConfig
	Main.AppLog("WriteConfig :: Start")
	Dim JSONGenerator As JSONGenerator
	Dim Data As List
    Data.Initialize
    Data.Add(gmapSettings) 
	JSONGenerator.Initialize2(Data)
	File.WriteString(File.DirApp, JSONfile, JSONGenerator.ToPrettyString(2))
	Main.AppLog("WriteConfig :: End")
End Sub

Sub readLocalization
	Main.AppLog("readLocalization :: Start")
	Dim parser As JSONParser
	parser.Initialize(File.ReadString(File.DirApp, JSONLocalize))
	Dim root As List = parser.NextArray
	'
	If gstrLanguage = "EN" Then
		gstrLanguage ="DE"
	Else
		gstrLanguage ="EN"
	End If
	For Each colroot As Map In root
		If colroot.Get("Language") = gstrLanguage Then
			btnSend.SetText(colroot.Get("btnsend"))
			btnConfiguration.SetText(colroot.Get("btnconfiguration"))
			btnAbout.SetText(colroot.Get("btnabout"))					
			lblTo.SetText(colroot.Get("lblto"))					
			lblSubject.SetText(colroot.Get("lblsubject"))					
			lblBody.SetText(colroot.Get("lblbody"))					
		End If
	Next 
	lblFooter.SetText("Localized to " & gstrLanguage)
	Main.AppLog("readLocalization :: End")
End Sub
